# Copyright (c) 2014 Dave Love, Liverpool University
# MIT licence, per Fedora policy

# fixme: unbundle pmrrr; library soversion

Name:		elemental
Version:	0.84.1
Release:	2%{?dist}
Summary:	Distributed-memory dense linear algebra

License:	BSD
URL:		http://libelemental.org/
Source0:	http://libelemental.org/pub/releases/Elemental-0.84-p1.tgz
Patch1:		elemental-soversion.patch
# The requirements suggest this, but ut doesn't appear actually to be
# necessary.
BuildRequires:	cmake
BuildRequires:	openmpi-devel mpich-devel openblas-devel
# needs to be scalapack 2
BuildRequires:	scalapack-openmpi-devel scalapack-mpich-devel
%if 0%{?el6}
BuildRequires:	devtoolset-3-gcc-c++ devtoolset-3-binutils
BuildRequires:	devtoolset-3-gcc-gfortran
%else
BuildRequires:	gcc-gfortran
%endif

%global desc \
Elemental is an open-source library for distributed-memory dense\
linear algebra which attempts to strike a careful balance between ease\
of use and high performance.\
\
Unique Features\
\
 * High-performance pseudospectral computation and visualization\
 * Quadratic-time low-rank Cholesky and LU modifications\
 * Bunch-Kaufman and Bunch-Parlett for accurate symmetric factorization\
 * LU and Cholesky with full pivoting\
 * Column-pivoted QR and interpolative/skeleton decompositions\
 * Quadratically Weighted Dynamic Halley iteration for the polar decomposition\
 * Spectral Divide and Conquer Schur decomposition and Hermitian EVD\
 * Many algorithms for Singular-Value soft-Thresholding (SVT)\
 * Tall-skinny QR decompositions\
 * Hermitian matrix functions\
 * Sign-based Lyapunov/Ricatti/Sylvester solvers

%description
%desc


%package openmpi
Summary:	Distributed-memory dense linear algebra - openmpi
Requires:	openmpi

%description openmpi
%desc

This is the openmpi version.

%package mpich
Summary:	Distributed-memory dense linear algebra - mpich
Requires:	mpich

%description mpich
%desc

This is the mpich version.

%package openmpi-devel
Summary:	Development files for %name-openmpi
Requires:	openmpi, %name-openmpi = %version-%release

%description openmpi-devel
Development files for %name-openmpi

%package mpich-devel
Summary:	Development files for %name-mpich
Requires:	mpich, %name-mpich = %version-%release

%description mpich-devel
Development files for %name-mpich


%prep
%setup -q -n Elemental-0.84-p1
%patch1 -p1 -b .soversion


%build

%global dobuild \
%cmake -DINCLUDE_INSTALL_DIR=$MPI_INCLUDE/elemental \\\
       -DLIB_INSTALL_DIR=$MPI_LIB \\\
       -DMATH_LIBS=-lopenblas -DELEM_SHARED_LIBRARIES=yes \\\
       -DCMAKE_SKIP_RPATH=yes .. \
make %{?_smp_mflags}

%if !0%{?fedora} && 0%{?rhel} < 7
PATH=/opt/rh/devtoolset-3/root/usr/bin:$PATH
%endif
mkdir openmpi
pushd openmpi
%_openmpi_load
%dobuild
%_openmpi_unload
popd

mkdir mpich
pushd mpich
%_mpich_load
%dobuild
%_mpich_unload
popd


%install
rm -rf $RPM_BUILD_ROOT

pushd openmpi
%_openmpi_load
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT$MPI_LIB $RPM_BUILD_ROOT$MPI_INCLUDE/elemental
mv $RPM_BUILD_ROOT%_prefix/lib/*.so* $RPM_BUILD_ROOT$MPI_LIB
mv $RPM_BUILD_ROOT%_prefix/include/{elemental,*h,*hpp} $RPM_BUILD_ROOT$MPI_INCLUDE/elemental
%_openmpi_unload
popd

pushd mpich
%_mpich_load
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT$MPI_LIB $RPM_BUILD_ROOT$MPI_INCLUDE/elemental
mv $RPM_BUILD_ROOT%_prefix/lib/*.so* $RPM_BUILD_ROOT$MPI_LIB
mv $RPM_BUILD_ROOT%_prefix/include/{elemental,*h,*hpp} $RPM_BUILD_ROOT$MPI_INCLUDE/elemental
%_mpich_unload
popd
rm $RPM_BUILD_ROOT%_prefix/conf/ElemVars


%clean
rm -rf $RPM_BUILD_ROOT


%{!?_licensedir:%global license %doc}

%files openmpi
%license LICENSE
%doc AUTHORS PUBLICATIONS.bib REFERENCES.bib README.md
%_libdir/openmpi/lib/*.so.*

%files mpich
%license LICENSE
%doc AUTHORS PUBLICATIONS.bib REFERENCES.bib README.md
%_libdir/mpich/lib/*.so.*

%files openmpi-devel
%_includedir/openmpi-%_arch/elemental
%_libdir/openmpi/lib/*.so

%files mpich-devel
%_includedir/mpich-%_arch/elemental
%_libdir/mpich/lib/*.so


%changelog
* Wed Dec 30 2015 Dave Love <loveshack@fedoraproject.org> - 0.84.1-2
- Use cmake, not cmake28
- Use devtoolset-3 on el6
- Add soversion

* Fri Oct  3 2014 Dave Love <d.love@liverpool.ac.uk> - 0.84.1-1
- Initial packaging
